UNIT WINDOWS;
(*
   (c) Martin Vogel und Ines Fronda 1988.

   Auszge (c) Charles C. Edwards

   Die Funktion DIRGET und dazugehrende Routinen entstanden in Anlehnung
   an den c't-Artikel "DIR IN A BOX" von Dennis Herzberg (c't 12/1988).
*)

INTERFACE

USES Dos,Crt;

TYPE
     WindowString     = String[80];

CONST
     Invers           = 120;

     KeinRahmen       = 0;
     EinfachRahmen    = 1;
     DoppelRahmen     = 2;

VAR
     WindowCount      : Integer;

FUNCTION OpenWindow(X1,Y1,X2,Y2,Rahmenart,Attribut : Byte;
                                       Ueberschrift:WindowString) : Byte;
(*
   Oeffnet ein Window in der angegebenen Rahmenart und gibt
   eine berschrift (so vorhanden) mittig im oberen Rahmen aus.

   Attribut ist das fr den Rahmen zu verwendende Textattribut.
   Hier kann 0 eingesetzt werden, um das aktuelle Attribut beizu-
   behalten. Fr den Text innerhalb des Fensters gilt diese Attribut
   nicht. Eine Interessante Kombination ist Rahmenart Leer (0) und
   Attribut Invers (120). Dies liefert einen soliden Rahmen.

   Folgendes (Fehler-)Argument wird zurckgegeben:
     0: Alles OK
     1: Angegebene Fenstergre unsinnig
     2: Kein Platz mehr auf dem Heap
     3: berschrift breiter als Window
*)


FUNCTION CloseWindow : Boolean;
(*
   Schliet das letzte Fenster und ist TRUE, wenn alle
   Fenster geschlossen sind
*)

(* Noch ein paar Sachen fr die Cursorgre: *)
PROCEDURE CursorEinstellen(Von,Bis:Byte);
Procedure ZeigCursor;
Procedure Hidecursor;

Function JaAntwort(Frage:WindowString):Boolean;

function DirGet(path:string):string;

IMPLEMENTATION

TYPE
     W_String             = Array[1..80] OF Integer;
     W_ScreenArray        = Array[1..25] OF W_String;
     W_ScreenBlock        = Array[1..2000] OF Integer;
     W_Link         = ^W_ControlBlock;
     W_ControlBlock = Record
                        X1,Y1,X2,Y2      : Byte;  {Fenster-Grenzen}
                        X,Y              : Byte;  {Cursor-Position}
                        ID               : Word;
                        BackLink         : W_Link;
                        W_ScreenContents : W_ScreenBlock; {Fensterinhalt}
                      END;
     W_CharSetBezeichner=(Waagerecht, Senkrecht,
                          LinksOben,  RechtsOben,
                          LinksUnten, RechtsUnten);
CONST
     W_CharSet:          Array[0..2,W_CharSetBezeichner] of char
                         =((' ',' ',' ',' ',' ',' '),
                           ('','','','','',''),
                           ('','','','','',''));
VAR
    W_Active_Window        : W_Link;
    W_Screen               :^W_ScreenArray;
    W_Fixed_Part           : Integer;
    W_MonoCard             : Boolean;
    C_vonZeile,
    C_bisZeile		   : Byte;



FUNCTION OpenWindow;

VAR
    Block     : W_Link;
LineLength,
WindowSize, i : Integer;
AltesAttr,
Y             : Byte;

BEGIN
  AltesAttr  := TextAttr;
  LineLength := X2-X1+1;
  If Length(Ueberschrift)+2 > LineLength Then
    Begin OpenWindow:=3; Exit; End;
  WindowSize := LineLength*(Y2-Y1+1)*2+W_Fixed_Part;
  IF (X2>80) OR (Y2>25) OR ((X2-X1)<2) OR ((Y2-Y1)<3) THEN
    Begin OpenWindow:=1; Exit; End;
  IF MaxAvail<WindowSize+1 THEN
    Begin OpenWindow:=2; Exit; End;
  GetMem(Block,WindowSize);
  Block^.X1:=X1;
  Block^.X2:=X2;
  Block^.Y1:=Y1;
  Block^.Y2:=Y2;
  Block^.X:=WhereX;
  Block^.Y:=WhereY;
  Block^.BackLink:=W_Active_Window;
  W_Active_Window:=Block;
  I:=1;
  FOR Y:=Y1 TO Y2 DO   {sichert den Bildschirminhalt}
  BEGIN
    Move(W_Screen^[y,X1],Block^.W_ScreenContents[i],LineLength*2);
    i:=i+LineLength;
  END;
  Window(X1,Y1,X2,Y2);
  ClrScr;
  WindowCount:=WindowCount+1;
  Block^.ID:=WindowCount;
  OpenWindow:=0;
  (*********** Ab hier um Rahmen ergnzt ***********)
  If Attribut<>0 then TextAttr:=Attribut;
  for i:=1 to (y2-y1-1) do
  begin
    gotoxy(1,i);write(W_CharSet[Rahmenart,Senkrecht]);
    gotoxy((LineLength),i);write(W_CharSet[Rahmenart,Senkrecht]);
  end;
  gotoxy((LineLength),y2-y1);write(W_CharSet[Rahmenart,RechtsUnten]);
  gotoxy(1,y2-y1);write(W_CharSet[Rahmenart,LinksUnten]);
  for i:=2 to x2-x1 do write(W_CharSet[Rahmenart,Waagerecht]);
  gotoxy(LineLength,1);
  insline;
  write(W_CharSet[Rahmenart,RechtsOben]);
  gotoxy(1,1);write(W_CharSet[Rahmenart,LinksOben]);
  for i:=2 to x2-x1 do write(W_CharSet[Rahmenart,Waagerecht]);
  If Length(Ueberschrift)<>0 then
  begin
    gotoxy(Linelength shr 1-Length(Ueberschrift) shr 1 , 1);
    write(' ',Ueberschrift,' ');
  end;
  window(x1+1,y1+1,x2-1,y2-1);
  TextAttr:=AltesAttr;
END;  {von OpenWindow}


FUNCTION CloseWindow;

VAR Block                     : W_Link;
    LineLength, WindowSize, i : Integer;
    Y                         : Byte;

BEGIN
  If W_Active_Window = NIL THEN
    CloseWindow:=TRUE
  ELSE
    BEGIN
      Block:=W_Active_Window;
      LineLength:=Block^.X2-Block^.X1+1;
      WindowSize:=lineLength*(Block^.Y2-Block^.Y1+1)*2+
                   W_Fixed_Part;
      i:=1;
      For Y:=Block^.Y1 to Block^.Y2 do    {stellt den Bildschirminhalt}
        BEGIN                             {wieder her}
          Move(Block^.W_ScreenContents[i],W_Screen^[Y,Block^.X1],
               LineLength*2);
          i:=i+LineLength;
        END;
      W_Active_Window:=Block^.backLink;
      If W_Active_Window = NIL THEN
        Window(1,1,80,25)
      ELSE With W_Active_Window^ DO
             Window(X1+1,Y1+1,X2-1,Y2-1);
             GotoXY(Block^.X,Block^.Y);
             Freemem(Block,WindowSize);
             WindowCount:=WindowCount-1;
             CloseWindow:=False;
    END;
END;   {von CloseWindow}


PROCEDURE InitWindow;
VAR Regs : Registers;
BEGIN
  Intr($11,Regs);                          {bestimmt Hardwarekonfiguration}
  W_MonoCard:=(Lo(Regs.AX) AND $30) = $30; {Monochrom- oder Farbadapter?}
  If W_MonoCard THEN
    W_Screen:=Ptr($B000,0)
  ELSE
    W_Screen:=PTR($B800,0);
  W_Active_Window:=NIL;
  W_Fixed_Part:=SizeOf(W_ControlBlock)-
                  SizeOf(W_ScreenBlock);

  WindowCount:=0;
END;   {von InitWindow}

PROCEDURE CursorEinstellen(Von,Bis:Byte);
var regs : registers;
begin
  regs.ax:=$0100;
  regs.cx:=(Von shl 8 + Bis);
  intr($10,regs);
  C_vonZeile:=von;
  C_bisZeile:=bis;
end;

PROCEDURE LiesCursorGroesse(var Von,Bis:Byte);
var r : registers;
begin
  r.ax:=$0300;
  r.bh:=0;
  intr($10,r);
  von:=r.ch;
  bis:=r.cl;
end;

Procedure ZeigCursor;
begin
  Cursoreinstellen(C_vonZeile,C_bisZeile);
end;

Procedure Hidecursor;
var v,b:byte;
begin
  v:=C_vonZeile;
  b:=C_bisZeile;
  Cursoreinstellen(32,0);
  C_bisZeile:=b;
  C_vonZeile:=v;
end;

Function JaAntwort(Frage:WindowString):Boolean;
VAR zeichen:Char;
begin
  write(Frage,' (J/N)?');
  repeat Zeichen:=Upcase(ReadKey) until Zeichen in ['J','N'];
  if Zeichen='J' then begin
			JaAntwort:=True;
			writeln('ja');
		      end
		 else begin
			JaAntwort:=False;
			writeln('nein');
		      end;
end;

(************  Ab hier gehrt alles zu DIRGET *************)

const NoAttr=$ff;
type
     str12=STRING[12];
     DirPointer=^DirRec;
     DirRec    =Record
                  Name:Str12;
                  Attr:Byte;
                  Time,
                  Size:LongInt;
                  Next:DirPointer;
                End;

var scrmono:array[1..25,1..80] of word absolute $b000:0000;
    scrcga :array[1..25,1..80] of word absolute $b800:0000;
    mono   :boolean;
    regs   :registers;

procedure freedir(Var dp:dirpointer);
begin
  if dp<>nil then
  begin
    if dp^.next <>nil then freedir(dp^.next);
    dispose(dp);
  end;
end;

procedure directwrite(x,y:byte;ac:word);
begin
  if mono then scrmono[y,x]:=ac else scrcga[y,x]:=ac;
end;

Function Directread(x,y:byte):Word;
begin
  if mono then Directread:=scrmono[y,x]
          else Directread:=scrcga[y,x];
end;

function expand(Name:str12):str12;
var a,b:byte;
    s:  str12;
begin
  a:=pos('.',name);
  if a>1 then
  begin
    s:='';
    for b:=a to 8 do s:=s+' ';
    insert(s,name,a);
  end;
  expand:=name;
end;

PROCEDURE ReadDir(Path:String;ja,nein:Byte;
                  VAR Fehler:Byte;
                  VAR Anzahl:Word;
                  VAR Start :DirPointer);
VAR Eintrag:SearchREC;
    NEu:DirPointer;

  PROCEDURE InsertList(VAR Alt,Neu:DirPointer);
  VAR P:DirPointer;
  BEGIN
    IF Alt=NIL then alt:=Neu
    ELSE
    If Alt^.Name>neu^.name then
      BEGIN
        P:=Alt; Alt:=Neu; Neu^.Next:=P;
      END
    ELSE
      If Alt^.Next=NIL Then
        Alt^.Next:=Neu
      ELSE
        InsertList(Alt^.Next,Neu);
  END;

  FUNCTION Test(Eintrag:Searchrec):Boolean;
  BEGIN
    With Eintrag do
      Test:=    (((Attr and ja)=ja) or (ja=noattr))
            and (((Attr and nein)=0) or (nein=NoAttr))
            and (Name<>'.');
  END;

BEGIN
  Anzahl:=0;
  FindFirst(Path,AnyFile,Eintrag);
  Fehler:=DOSError;
  If (Fehler=0) and Test(eintrag) Then
  begin
    Inc(anzahl);
    new(neu);
    with neu^ do
    begin
      Name:=Eintrag.name;
      Attr:=Eintrag.Attr;
      Time:=Eintrag.Time;
      Size:=Eintrag.Size;
      Next:=NIL;
    end;
    InsertList(Start,Neu);
  End;
  While Fehler=0 do
  begin
    FindNext(Eintrag);
    Fehler:=Doserror;
    If (Fehler=0) and Test(Eintrag) then
    begin
      New(neu);
      Inc(Anzahl);
      With neu^ do
      begin
        Name:=Eintrag.name;
        Attr:=Eintrag.Attr;
        Time:=Eintrag.Time;
        Size:=Eintrag.Size;
        Next:=NIL;
      end;
      InsertList(Start,Neu);
    End;
  end;
end;

Function SelectDirRec(Titel:String; Start:DirPointer):DirPointer;
VAR Zeile,Spalte,
    Ausschn,MaxAusschn                  :Byte;
    Anzahl                              :Integer;
    Ende                                :Boolean;
    Ch1,Ch2                             :Char;
    St                                  :String[14];
    StoreScr                            :Pointer;
    P                                   :DirPointer;
    PointerList                         :Array[0..3,1..8] of DirPointer;

  PROCEDURE BildAufbau;
  VAR lv,s,z:Byte;
      Test  :Boolean;
  BEGIN
    For S:=0 to 3 do
      For z:=1 to 8 do
        PointerList[s,z]:=nil;
    TextAttr:=112;
    p:=Start;
    s:=0;
    Z:=1;
    clrscr;
    For lv:=1 to Ausschn*4 do P:=p^.next;
    REPEAT
      gotoxy(3+s*16,z);
      pointerlist[s,z]:=p;
      if (p^.attr and directory)=Directory then Write(p^.name,'\')
      ELSE write(Expand(p^.name));
      TEst:=(p^.Next=nil) or ((Z=8) and (s=3));
      If not Test then
      begin
        p:=p^.next;
        s:=(s+1) mod 4;
        if s=0 then inc(z);
      end;
    UNTIL Test;
  END; {BildAufbau}

BEGIN {SelectDirRec}
  if closewindow then;
  if openwindow(8,9,73,18,einfachrahmen,112,' '+titel+' ') <>0 then exit;
  SelectDirRec:=Nil;
  If Start=Nil then exit;
  Zeile:=1;
  Spalte:=0;
  Ausschn:=0;
  p:=Start;
  Anzahl:=1;
  While p^.next<> nil do
  BEGIN
    Inc(Anzahl);
    P:=p^.next;
  END;
  Anzahl:=Anzahl-32;
  If Anzahl<1 then Maxausschn:=0
  ELSE
    MaxAusschn:=(Anzahl+3) div 4;
  BildAufbau;
  Ende:=False;
  Repeat
    Gotoxy(2+Spalte*16,Zeile);
    TextAttr:=15;
    With Pointerlist[Spalte,Zeile]^ do
    If (Attr and directory)=directory then st:=' '+name+'\'
    ELSE st:=' '+expand(name);
    write(st,'':14-length(st));
    ch1:=ReadKey;
    case ch1 of
      #27:   BEGIN
               SelectDirRec:=Nil;
               Ende:=True;
             END;
      #13:   BEGIN
               SelectDirREc:=PointerList[Spalte,zeile];
               Ende:=True;
             END;
      #0:    BEGIN
               Ch2:=ReadKey;
               If (ch2<>#73) and (ch2<>#81) then
               BEGIN
                 gotoxy(2+Spalte*16,Zeile);
                 TextAttr:=112;
                 With Pointerlist[Spalte,Zeile]^ do
                   if (attr and directory)=Directory then
                     st:=' '+name+'\'
                   ELSE
                     st:=' '+expand(name);
                 Write(st,'':14-length(st));
               END;
               case ch2 of
                 #72:  If Zeile> 1 then dec(Zeile)
                       else
                         if Ausschn>0 then
                         begin
                           dec(ausschn);
                           bildaufbau;
                         end;
                 #80:  If Zeile<8 Then
                       begin
                         if pointerlist[spalte,zeile+1]<>nil
                           then inc(Zeile);
                       end
                       ELSE
                       if ausschn<maxausschn then
                       begin
                         inc(Ausschn);
                         bildaufbau;
                         while pointerlist[spalte,zeile]=nil do
                           dec(Spalte);
                       end;
                 #75:  If Spalte>0 then dec(Spalte);
                 #77:  If Spalte<3 then
                         if pointerlist[spalte+1,zeile]<>nil
                           then inc(Spalte);
                 #73:  If Ausschn>0 then
                       begin
                         if ausschn<8 then ausschn:=0
                         else dec(ausschn,8);
                         Bildaufbau;
                       end;
                 #81:  If Ausschn<MaxAusschn then
                       begin
                         if ausschn>(maxausschn-8) then ausschn:=maxausschn
                         else inc(ausschn,8);
                         Bildaufbau;
                         while pointerlist[spalte,zeile]=nil do
                           dec(Spalte);
                       end;
               end; {case ch2}
             end;
    end; {case ch1}
  Until ende;
END;

function DirGet(path:string):string;
Label Ende;
VAR Test:            Boolean;
    LV,Fehler,
    altattr:         Byte;
    Anz1,Anz2:       Word;
    AltDir,Suchweg,
    Wildcard:        String;
    StoreScr:        Pointer;
    DP1,DP2:         DirPointer;
BEGIN
  altattr:=textattr;
  textattr:=112;
  hidecursor;
  if openwindow(8,9,73,18,einfachrahmen,112,' ... warten ... ') <>0 then exit;
  clrscr;
  DirGet:='';
  GetDir(0,AltDir);
  DP1:=NIL;
  LV:=Length(Path);
  While (Path[LV]<>'\') AND (Path[LV]<>':') AND (LV>0) do dec(LV);
  IF LV=Length(Path) THEN
    BEGIN
      SUchweg:=Path;
      Wildcard:='*.*';
    END
  ELSE
    BEGIN
      Suchweg:=Copy(PAth,1,lv);
      Wildcard:=Copy(Path,lv+1,length(path)-lv);
    end;
  LV:=Length(Suchweg);
  If (Suchweg[lv]='\') and (Suchweg[lv-1]<>':')
    THEN Suchweg:=copy(Suchweg,1,lv-1);
  If Suchweg<>'' Then
    BEGIN
      ChDir(Suchweg);
      If IOResult<>0 then Goto ENDE;
    END;
  REpeat
    ReadDir('*.*',Directory,NoAttr,Fehler,Anz1,DP1);
    If Fehler<>18 then goto ende;
    If dp1 <> nil then
      begin
        dp2:=dp1;
        while dp2^.next<>nil do
          dp2:=dp2^.next;
        REadDir(Wildcard,NoAttr,Directory+VolumeId,Fehler,Anz2,Dp2^.next);
      end
    ELSE
      REadDir(WildCard,NoAttr,Directory+VolumeId,Fehler,Anz2,Dp1);
    If (Fehler<>18) or (Anz1+Anz2=0) then goto ende;
    GetDir(0,Suchweg);
    If Length(Suchweg)>3 then Suchweg:=Suchweg+'\';
    DP2:=SelectDirRec(Suchweg+Wildcard,dp1);
    Test:=True;
    If dp2<>nil then
      if (dp2^.attr and directory) = directory then
        begin
          chdir(dp2^.name);
          Test:=False;
        end
      ELSE
        DirGet:=Suchweg+dp2^.name;
    FreeDir(dp1);
    DP1:=nil;
  Until Test;
  ENDE:
  Chdir(Altdir);
  if ioresult<>0 then;
  If dp1<>nil then freedir(dp1);
  if closewindow then;
  zeigcursor;
  textattr:=altattr;
end;

Begin
   LiesCursorGroesse(C_vonZeile,C_bisZeile);
   InitWindow;
End.
